package net.coreprotect.utility;

import org.bukkit.ChatColor;

public final class Color {

    // we define our own constants here to eliminate string concatenation
    // javadoc taken from org.bukkit.ChatColor

    /**
     * Represents black.
     */
    public static final String BLACK = ChatColor.BLACK.toString();

    /**
     * Represents dark blue.
     */
    public static final String DARK_BLUE = ChatColor.DARK_BLUE.toString();

    /**
     * Represents dark green.
     */
    public static final String DARK_GREEN = ChatColor.DARK_GREEN.toString();

    /**
     * Represents dark blue (aqua).
     */
    public static String DARK_AQUA = ChatColor.DARK_AQUA.toString();

    /**
     * Represents dark red.
     */
    public static final String DARK_RED = ChatColor.DARK_RED.toString();

    /**
     * Represents dark purple.
     */
    public static final String DARK_PURPLE = ChatColor.DARK_PURPLE.toString();

    /**
     * Represents gold.
     */
    public static final String GOLD = ChatColor.GOLD.toString();

    /**
     * Represents grey.
     */
    public static final String GREY = ChatColor.GRAY.toString();

    /**
     * Represents dark grey.
     */
    public static final String DARK_GREY = ChatColor.DARK_GRAY.toString();

    /**
     * Represents blue.
     */
    public static final String BLUE = ChatColor.BLUE.toString();

    /**
     * Represents green.
     */
    public static final String GREEN = ChatColor.GREEN.toString();

    /**
     * Represents aqua.
     */
    public static final String AQUA = ChatColor.AQUA.toString();

    /**
     * Represents red.
     */
    public static final String RED = ChatColor.RED.toString();

    /**
     * Represents light purple.
     */
    public static final String LIGHT_PURPLE = ChatColor.LIGHT_PURPLE.toString();

    /**
     * Represents yellow.
     */
    public static final String YELLOW = ChatColor.YELLOW.toString();

    /**
     * Represents white.
     */
    public static final String WHITE = ChatColor.WHITE.toString();

    /**
     * Represents magical characters that change around randomly.
     */
    public static final String MAGIC = ChatColor.COLOR_CHAR + "k";

    /**
     * Makes the text bold.
     */
    public static final String BOLD = ChatColor.COLOR_CHAR + "l";

    /**
     * Makes a line appear through the text.
     */
    public static final String STRIKETHROUGH = ChatColor.COLOR_CHAR + "m";

    /**
     * Makes the text appear underlined.
     */
    public static final String UNDERLINE = ChatColor.COLOR_CHAR + "n";

    /**
     * Makes the text italic.
     */
    public static final String ITALIC = ChatColor.COLOR_CHAR + "o";

    /**
     * Resets all previous chat colors or formats.
     */
    public static final String RESET = ChatColor.COLOR_CHAR + "r";

    private Color() {
        throw new IllegalStateException("Utility class");
    }

}
